<?php

// $Id: input_formats.features.inc,v 1.1 2010/06/05 01:42:10 dagmar Exp $

/**
 * Implementation of hook_features_export_options().
 */
function input_formats_features_export_options() {
  $input_formats = array();
  $query = 'SELECT ff.format, ifo.name machine_name, ff.name name 
            FROM {filter_formats} ff 
            INNER JOIN {input_formats} ifo ON ifo.format = ff.format';
  $result = db_query($query);
  while ($format = db_fetch_object($result)) {
    $input_formats[$format->machine_name] = check_plain($format->name);
  }

  ksort($input_formats);
  return $input_formats;
}

/**
 * Implementation of hook_features_export_render().
 */
function input_formats_features_export_render($module = 'foo', $data) {
  $code = array();
  $ident = "  ";
  $code[] = '  $input_formats = array();';
  $code[] = '';

  foreach ($data as $input_format_name) {
    // Export the input format
    $input_format = array();
    $input_format = input_formats_api_load($input_format_name);
    if ($input_format['machine_name']) {
      if ($input_format) {
        $code[] = '  // Exported input format: '. $input_format_name;
        $code[] = '  $input_format = ' . input_formats_api_export($input_format, $ident);
        $code[] = '  $input_formats[\'' . $input_format_name  . '\'] = $input_format;';
        $code[] = '';
      }
    }
  }
  $code[] = '  return $input_formats;';
  $code = implode("\n", $code);
  return array('input_formats_default' => $code);
}

/**
 * Implementation of hook_features_export().
 */
function input_formats_features_export($data, &$export, $module_name = '') {

  if (!isset($export['features']['input_formats'])) {
    $export['features']['input_formats'] = array();
  }

  foreach ($data as $input_format_name) {
    // Add to exports
    $export['features']['input_formats'][$input_format_name] = $input_format_name;
    // Add dependencies for the export
    $input_format = input_formats_api_load($input_format_name);
    $dependencies = input_formats_api_dependencies($input_format);
    foreach ($dependencies as $module) {
      $export['dependencies'][$module] = $module;
    }
  }
  $export['dependencies']['input_formats'] = 'input_formats';
}

/**
 * Implementation of hook_features_revert().
 */
function input_formats_features_revert($module) {
  // @TODO
}

/**
 * Implementation of hook_features_rebuild().
 */
function input_formats_features_rebuild($module) {
  // @TODO
}
